unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  n:integer;
  g:array[1..10,1..10] of integer;
  x1,y1:array [1..10] of integer;
  d,p:array[1..10] of integer; 

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  n:=0;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Label1.Visible:=False;
  if Button1.Visible and (n<10) then
    begin
      inc(n);
      Image1.Canvas.TextOut(x,y,IntToStr(n));
      x1[n]:=x;
      y1[n]:=y;
    end;
  if n=2 then Button1.Enabled:=True;  
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Button2.Visible:=True;
  Button3.Visible:=True;
  Button1.Visible:=False;
  Edit1.Visible:=True;
  Edit2.Visible:=True;
end;

procedure TForm1.Button2Click(Sender: TObject);
var z,k:integer;
begin
  z:=StrToInt(Edit1.Text);
  k:=StrToInt(Edit2.Text);
  g[z,k]:=round(sqrt((x1[z]-x1[k])*(x1[z]-x1[k])+(y1[z]-y1[k])*(y1[z]-y1[k])));
  g[k,z]:=round(sqrt((x1[z]-x1[k])*(x1[z]-x1[k])+(y1[z]-y1[k])*(y1[z]-y1[k])));
  Image1.Canvas.MoveTo(x1[z],y1[z]);
  Image1.Canvas.LineTo(x1[k],y1[k]);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Button2.Visible:=False;
  Button3.Visible:=False;
  Edit2.Visible:=False;
  Edit1.Visible:=False;
  Button4.Visible:=True;
end;

procedure TForm1.Button4Click(Sender: TObject);
var s,v,min,u,riadok,t:integer;
    m,q:set of 1..10;
begin
  s:=1;
  for v:=1 to n do begin d[v]:=1000000; p[v]:=0 end;
  d[s]:=0;
  m:=[];
  q:=[]; for v:=1 to n do q:=q+[v];
  while (q<>[]) do
    begin
      min:=1000000;
      for v:=1 to n do
        if (v in q) and (d[v]<min) then begin u:=v; min:=d[v]; end;
      q:=q-[u];
      m:=m+[u];
      for v:=1 to n do
        if g[u,v]>0 then
          if d[v]>d[u]+g[u,v] then begin d[v]:=d[u]+g[u,v];p[v]:=u end;
    end;
  {vypis}
  riadok:=1;
  Memo1.Visible:=True;
  m:=[];
  t:=n;
  Image1.Canvas.Pen.Color:=ClRed;
  Image1.Canvas.MoveTo(x1[t],y1[t]);
  u:=t;
  while true do
    begin
      m:=[u]+m;
      Memo1.Lines[riadok]:=IntToStr(u);
      Image1.Canvas.LineTo(x1[u],y1[u]);
      inc(riadok);
      if u=s then break;
      u:=p[u];
    end;
  Button4.Visible:=False;  
end;

end.
